<?php
/*
Plugin Name: WP-Appbox
Plugin URI: http://www.blogtogo.de/wp-appbox-app-badge-fuer-google-play-mac-app-store-windows-store-windows-phone-store-co/
Description: "WP-Appbox" ermöglicht es, via Shortcode schnell und einfach App-Details von Apps aus einer Reihe an App Stores in Artikeln oder Seiten anzuzeigen.
Author: Marcel Schmilgeit
Version: 3.2.0
Author URI: http://www.blogtogo.de
*/


/*
Copyright (C)  2012-2015 Marcel Schmilgeit

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/


/* Ein paar Variablen */
$wpAppboxFirstShortcode = true;
load_plugin_textdomain( 'wp-appbox', false, dirname( plugin_basename( __FILE__ ) ) . '/lang' );


/* Includierung benötigter Scripte */
include_once( "inc/definitions.php" );
include_once( "inc/getstoreurls.class.php" );
include_once( "inc/getappinfo.class.php" );
include_once( "inc/createattributs.class.php" );
include_once( "inc/createoutput.class.php" );
include_once( "inc/appboxdb.php" );
include_once( "admin/admin.php" );
include_once( "admin/user-profiles.php" );
require_once( ABSPATH . "wp-includes/pluggable.php" );


/**
* Testfunktion, wird derzeit noch nicht genutzt und wieder entfernt
*
* @since   3.2.0
*
* @param   string  $url  URL der Bilddatei
*/

function wpAppbox_loadFile( $url = NULL ) {
	if ( ini_get( 'allow_url_fopen' ) && $url !== NULL ) {
		$bsn = md5( basename( $url ) );
		$file = file_get_contents( $url );
		//if ( file_put_contents(WPAPPBOX_CACHE_DIR.$bsn, file_get_contents( $url ), LOCK_EX ) ) print_r( "fool" );
		echo( '<img src="//'.WPAPPBOX_CACHE_DIR.$bsn.'" alt="" />' );
	}
}
//wpAppbox_loadFile('http://a4.mzstatic.com/eu/r30/Purple6/v4/8a/f1/8b/8af18b89-c3aa-7d4c-8157-091efbfcd19e/icon512.png');


/**
* Prüfen ob der Nutzer Autor (min. User-Level 2) ist
*
* @since   2.0.0
* @change  3.2.0
*
* @return  boolean  true/false  TRUE when author
*/

function wpAppbox_isUserAuthor() {
	$userdata = get_userdata( get_current_user_id() );
	if ( intval( $userdata->user_level ) >= 2 ) {
		return( true );
	} else {
		return( false );
	}
}


/**
* Prüfen ob der Nutzer Admin (min. User-Level 9) ist
*
* @since   2.0.0
* @change  3.2.0
*
* @return  boolean  true/false  TRUE when admin
*/

function wpAppbox_isUserAdmin() {
	$userdata = get_userdata( get_current_user_id() );
	if ( intval( $userdata->user_level ) >= 9 ) {
		return( true );
	} else {
		return( false );
	}
}


/**
* Ausgabe der Fehlermeldungen
*
* @since   2.0.0
* @change  3.2.0
*
* @param   string  $output  Fehlermeldung [optional]
* @print   error message
*/

function wpAppbox_errorOutput( $output = "" ) {
	if ( get_option( "wpAppbox_eOutput" ) && wpAppbox_isUserAdmin() ) {
		print_r( "<pre>$output</pre>" );
	}
}


/**
* Prüfen ob "?wpappbox_nocache" angehangen
*
* @since   2.0.0
* @change  3.2.0
*
* @return  boolean  true/false  TRUE when $_GET[]
*/

function wpAppbox_isCacheInactive() {
	if ( wpAppbox_isUserAuthor() ) {
		if( isset( $_GET['wpappbox_nocache'] ) ){
			 return( true );
		} else {
			return( false );
		}
	}
}


/**
* Prüfen ob "?wpappbox_reload_cache" angehangen
*
* @since   2.0.0
* @change  3.2.0
*
* @return  boolean  true/false  TRUE when $_GET[]
*/

function wpAppbox_forceNewCache( $appID ) {
	if ( wpAppbox_isUserAuthor() ) {
		if ( ( isset( $_GET["wpappbox_reload_cache"] ) ) || ( isset( $_GET["action"] ) && $_GET["action"] === 'wpappbox_reload_cache' ) ) {
			if ( !isset( $_GET["wpappbox_cacheid"] ) ) {
				return( true );
			} elseif ( $_GET["wpappbox_cacheid"] === $appID ) {
				return( true );
			}
		}
	}
	return( false );
}


/**
* Einlesen des Templates
*
* @since   2.0.0
* @change  3.2.0
*
* @param   string   $styleName      Verwendeter Stil
* @param   boolean  $themeTemplate  Deprecated [optional]
* @return  string   $tpl            Ausgabe des Banners
*/

function wpAppbox_loadTemplate( $styleName, $themeTemplate = false ) {
	ob_start();
	if ( file_exists( get_template_directory() . "/wpappbox-$styleName.php" ) ) {
		include( get_template_directory()."/wpappbox_$styleName.php" );
	} else {
		include( "tpl/$styleName.php" );
	}
	$tpl = ob_get_contents();
	ob_end_clean();
	return( $tpl );
}


/**
* Löscht den Seiten-Cache eines Cache-Plugins
*
* @since   3.2.0
*
* @param   string    $postID       ID des Posts
*/

function wpAppbox_clearCachePlugin( $postID = '') {
	global $post;
	$postID = $post->ID;
	if ( $postID != '' ) {
		$usedPlugin = get_option( 'wpappbox_cachePlugin' );
		switch ( $usedPlugin ) {
			case 'cachify':
				if ( has_action( 'cachify_remove_post_cache' ) ) {
				    do_action( 'cachify_remove_post_cache', $postID );
				}
				break;
			case 'w3-total-cache':
				if ( function_exists( 'w3tc_pgcache_flush_post' ) ) {
					w3tc_pgcache_flush_post( $postID );
				}
			case 'wp-super-cache':
				if ( function_exists( 'wp_cache_post_change' ) ) {
					$GLOBALS["super_cache_enabled"] = 1;
					wp_cache_post_change( $postID );
				}
				break;
			case 'wp-rocket':
				if ( function_exists( 'rocket_clean_post' ) ) {
					rocket_clean_post( $postID );
				}
				break;
			case 'wp-fastest-cache':
				if ( isset( $GLOBALS['wp_fastest_cache'] ) && method_exists( $GLOBALS['wp_fastest_cache'], 'singleDeleteCache' ) ) {
					$GLOBALS['wp_fastest_cache']->singleDeleteCache( false, $postID );
				}
				break;
			case 'zencache':
				if ( isset( $GLOBALS['zencache'] ) && method_exists( $GLOBALS['zencache'], 'auto_clear_post_cache' ) ) {
					$GLOBALS['zencache']->auto_clear_post_cache( $postID );
				}
				break;
		}
	}
}


/**
* Prüfen ob Versionsnummer älter oder neuer
*
* @since   3.1.6
* @change  3.2.0
*
* @param   string   $this_ver   Aktuelle Version
* @param   string   $com_ver    Version zu prüfen
* @return  boolean  true/false  TRUE when $this_ver neuer
*/

function wpAppbox_checkOlderVersion( $this_ver = "", $comp_ver = "1.0.0" ) {
	if ( $this_ver == '' ) $this_ver = WPAPPBOX_PLUGIN_VERSION;
	if ( $comp_ver == '' ) $comp_ver = get_option( "wpAppbox_pluginVersion" );
	$this_ver = str_replace( ".", "", $this_ver );
	$comp_ver = str_replace( ".", "", $comp_ver );
	if ( $comp_ver < $this_ver ) {
		return( true );
	}
}


/**
* Appbox-Banner erstellen und ausgeben
*
* @since   2.0.0
* @change  3.2.0
*
* @param   string  $appboxAttributs  Attribute des Shortcodes
* @param   string  $content          Inhalte des Shortcodes [deprecated]
* @return  string  $output           Ausgabe des Banners
*/

function wpAppbox_createAppbox( $appboxAttributs, $content ) {
	global $wpAppboxFirstShortcode;
	$attr = new wpAppbox_CreateAttributs;
	$attr = $attr->devideAttributs( $appboxAttributs );
	$output = new wpAppbox_CreateOutput;
	$output = $output->theOutput( $attr );
	if ( $wpAppboxFirstShortcode ) {
		wpAppbox_RegisterStyle();
		wpAppbox_loadFonts();
		$wpAppboxFirstShortcode = false;
	}
	return( $output );
}


/**
* Benötigte Update-Funktionen durchführen
*
* @since   3.1.6
* @change  3.2.0
*/

function wpAppbox_UpdateAction() {
	if ( get_option("wpAppbox") !== false ) wpAppbox_updateOptions();
	if ( wpAppbox_checkOlderVersion("3.2.0") ) {
		wpAppbox_setOptions();
		wpAppbox_createTable();
		wpAppbox_transformTransients();
	}
	update_option( "wpAppbox_pluginVersion", WPAPPBOX_PLUGIN_VERSION );
}


/**
* Neue Optionen in wp_options einfügen
*
* @since   3.1.6
* @change  3.2.0
*/

function wpAppbox_setOptions() {
	global $wpAppbox_optionsDefault, $wpAppbox_storeNames;
	foreach ( $wpAppbox_optionsDefault as $key => $value ) {
		$key = 'wpAppbox_'.$key;
		if ( get_option( $key ) === false ) update_option( $key, $value );
	}
	foreach ( $wpAppbox_storeNames as $storeID => $storeName ) {
		$key_defaultStyle = "wpAppbox_defaultStyle_$storeID";
		$key_buttonAppbox = "wpAppbox_buttonAppbox_$storeID";
		$key_buttonWYSIWYG = "wpAppbox_buttonWYSIWYG_$storeID";
		$key_buttonHTML = "wpAppbox_buttonHTML_$storeID";
		$key_buttonHidden = "wpAppbox_buttonHidden_$storeID";
		$key_storeURL = "wpAppbox_storeURL_$storeID";
		$key_storeURL_URL = "wpAppbox_storeURL_URL_$storeID";
		if ( get_option($key_defaultStyle ) === false ) {
			update_option( $key_defaultStyle, intval( "0" ) );
		}
		if ( get_option($key_buttonWYSIWYG ) === false ) {
			update_option( $key_buttonWYSIWYG, true );
		}
		if ( get_option($key_buttonHTML ) === false ) {
			update_option( $key_buttonHTML, true );
		}
		if ( get_option($key_storeURL ) === false ) {
			update_option( $key_storeURL, intval( "1" ) );
		}
		if ( get_option($key_storeURL_URL ) === false ) {
			update_option( $key_storeURL_URL, "" );
		}
	}
	update_option( "wpAppbox_pluginVersion", WPAPPBOX_PLUGIN_VERSION );
}


wpAppbox_setOptions();
/**
* Alte Optionen übernehmen [deprecated]
*
* @since   3.1.6
* @change  3.2.0
* @remove  >3.1.x
*/

//Für ältere Versionen ==> bis 3.1.6
function wpAppbox_updateOptions() {
	$oldSettings = get_option( "wpAppbox" );
	if ( !empty( $oldSettings ) ) {
		global $wpAppbox_optionsDefault, $wpAppbox_storeNames;
		if ( $oldSettings['wpAppbox_datacachetime'] != '' ) update_option( 'wpAppbox_cacheTime', $oldSettings['wpAppbox_datacachetime'] );
		if ( $oldSettings['wpAppbox_nofollow'] != ('' || false) ) update_option( 'wpAppbox_nofollow', $oldSettings['wpAppbox_nofollow'] );
		if ( $oldSettings['wpAppbox_blank'] != ('' || false) ) update_option( 'wpAppbox_targetBlank', $oldSettings['wpAppbox_blank'] );
		if ( $oldSettings['wpAppbox_showrating'] != ('' || false) ) update_option( 'wpAppbox_showRating', $oldSettings['wpAppbox_showrating'] );
		if ( $oldSettings['wpAppbox_colorful'] != ('' || false) ) update_option( 'wpAppbox_colorfulIcons', $oldSettings['wpAppbox_colorful'] );
		if ( $oldSettings['wpAppbox_show_reload_link'] != ('' || false) ) update_option( 'wpAppbox_showReload', $oldSettings['wpAppbox_show_reload_link'] );
		if ( $oldSettings['wpAppbox_downloadtext'] != '' ) update_option( 'wpAppbox_downloadCaption', $oldSettings['wpAppbox_downloadtext'] );
		if ( $oldSettings['wpAppbox_useownsheet'] != ('' || false) ) update_option( 'wpAppbox_disableCSS', $oldSettings['wpAppbox_useownsheet'] );
		if ( $oldSettings['wpAppbox_avoid_loadfonts'] != ('' || false) ) update_option( 'wpAppbox_disableFonts', $oldSettings['wpAppbox_avoid_loadfonts'] );
		if ( $oldSettings['wpAppbox_error_onlyforauthor'] != ('' || false) ) update_option( 'wpAppbox_eOnlyAuthors', $oldSettings['wpAppbox_error_onlyforauthor'] );
		if ( $oldSettings['wpAppbox_error_erroroutput'] != ('' || false) ) update_option( 'wpAppbox_eOutput', $oldSettings['wpAppbox_error_erroroutput'] );
		if ( $oldSettings['wpAppbox_itunes_secureimage'] != ('' || false) ) update_option( 'wpAppbox_eImageApple', $oldSettings['wpAppbox_itunes_secureimage'] );
		if ( $oldSettings['wpAppbox_curl_timeout'] != '' ) update_option( 'wpAppbox_curlTimeout', $oldSettings['wpAppbox_curl_timeout'] );
		if ( $oldSettings['wpAppbox_user_affiliateids'] != ('' || false) ) update_option( 'wpAppbox_userAffiliate', $oldSettings['wpAppbox_user_affiliateids'] );
		if ( $oldSettings['wpAppbox_affid'] != '' ) update_option( 'wpAppbox_affiliateApple', $oldSettings['wpAppbox_affid'] );
		if ( $oldSettings['wpAppbox_affid_sponsored'] != ('' || false) ) update_option( 'wpAppbox_affiliateAppleDev', $oldSettings['wpAppbox_affid_sponsored'] );
		if ( $oldSettings['wpAppbox_affid_amazonpartnernet'] != '' ) update_option( 'wpAppbox_affiliateAmazon', $oldSettings['wpAppbox_affid_amazonpartnernet'] );
		if ( $oldSettings['wpAppbox_affid_amazonpartnernet_sponsored'] != ('' || false) ) update_option( 'wpAppbox_affiliateAmazonDev', $oldSettings['wpAppbox_affid_amazonpartnernet_sponsored'] );
		if ( $oldSettings['wpAppbox_view_default'] != '' ) update_option( 'wpAppbox_defaultStyle', $oldSettings['wpAppbox_view_default'] );
		if ( $oldSettings['wpAppbox_button_default'] != '' ) update_option( 'wpAppbox_defaultButton', $oldSettings['wpAppbox_button_default'] );
		foreach ( $wpAppbox_storeNames as $storeID => $storeName ) {
			$key_defaultStyle = "wpAppbox_defaultStyle_$storeID";
			$key_buttonAppbox = "wpAppbox_buttonAppbox_$storeID";
			$key_buttonWYSIWYG = "wpAppbox_buttonWYSIWYG_$storeID";
			$key_buttonHTML = "wpAppbox_buttonHTML_$storeID";
			$key_buttonHidden = "wpAppbox_buttonHidden_$storeID";
			$key_storeURL = "wpAppbox_storeURL_$storeID";
			$key_storeURL_URL = "wpAppbox_storeURL_URL_$storeID";
			if ( $oldSettings['wpAppbox_view_'.$storeID] != '' ) update_option( $key_defaultStyle, intval( $oldSettings["wpAppbox_view_$storeID"] ) );
			if ( $oldSettings['wpAppbox_button_appbox_'.$storeID] != ('' || false) ) update_option( $key_buttonAppbox, $oldSettings["wpAppbox_button_appbox_$storeID"] );
			if ( $oldSettings['wpAppbox_button_alone_'.$storeID] != ('' || false) ) update_option( $key_buttonWYSIWYG, $oldSettings["wpAppbox_button_alone_$storeID"] );
			if ( $oldSettings['wpAppbox_button_html_'.$storeID] != ('' || false) ) update_option( $key_buttonHTML, $oldSettings["wpAppbox_button_html_$storeID"] );
			if ( $oldSettings['wpAppbox_button_hidden_'.$storeID] != ('' || false) ) update_option( $key_buttonHidden, $oldSettings["wpAppbox_button_hidden_$storeID"] );
			if ( $oldSettings['wpAppbox_storeurl_'.$storeID] != ('' || false) ) update_option( $key_storeURL, intval( $oldSettings["wpAppbox_storeurl_$storeID"] ) );
			if ( $oldSettings['wpAppbox_storeurl_url'.$storeID] != ('' || false) ) update_option( $key_storeURL_URL, $oldSettings["wpAppbox_storeurl_url$storeID"] );
		}
		update_option('wpAppbox_pluginVersion', WPAPPBOX_PLUGIN_VERSION);
		delete_option('wpAppbox'); //Für ältere Versionen ==> bis 3.1.6
	}
}


/**
* Buttons zum WYSIWYG-Editor hinzufügen
*
* @since   2.0.0
* @change  3.2.0
*
* @param   array  $buttons  Buttons [WordPress]
* @return  array  $buttons  Buttons [WordPress]
*/

function wpAppbox_addButtonsWYSIWYG( $buttons ) {
	$option = get_option("wpAppbox_defaultButton");
	if ( ( $option == '0' || '3' ) ) {
		if ( get_option('wpAppbox_buttonWYSIWYG_amazonapps') || $option == '0' ) {
			array_push( $buttons, 'separator', 'wpAppbox_AmazonAppsButton' );
		}
		if ( get_option('wpAppbox_buttonWYSIWYG_appstore') || $option == '0' ) {
			array_push( $buttons, 'separator', 'wpAppbox_AppStoreButton' );
		}
		if ( get_option('wpAppbox_buttonWYSIWYG_chromewebstore') || $option == '0' ) {
			array_push( $buttons, 'separator', 'wpAppbox_ChromeWebStoreButton' );
		}
		if ( get_option('wpAppbox_buttonWYSIWYG_firefoxaddon') || $option == '0' ) {
			array_push( $buttons, 'separator', 'wpAppbox_FirefoxAddonButton' );
		}
		if ( get_option('wpAppbox_buttonWYSIWYG_firefoxmarketplace') || $option == '0' ) {
			array_push( $buttons, 'separator', 'wpAppbox_FirefoxMarketplaceButton' );
		}
		if ( get_option('wpAppbox_buttonWYSIWYG_googleplay') || $option == '0' ) {
			array_push( $buttons, 'separator', 'wpAppbox_GooglePlayButton' );
		}
		if ( get_option('wpAppbox_buttonWYSIWYG_operaaddons') || $option == '0' ) {
			array_push( $buttons, 'separator', 'wpAppbox_OperaAddonsButton' );
		}
		if ( get_option('wpAppbox_buttonWYSIWYG_steam') || $option == '0' ) {
			array_push( $buttons, 'separator', 'wpAppbox_SteamButton' );
		}
		if ( get_option('wpAppbox_buttonWYSIWYG_windowsstore') || $option == '0' ) {
			array_push( $buttons, 'separator', 'wpAppbox_WindowsStoreButton' );
		}
		if ( get_option('wpAppbox_buttonWYSIWYG_wordpress') || $option == '0' ) {
			array_push( $buttons, 'separator', 'wpAppbox_WordPressButton' );
		}
	}
	if ( ( $option == '1' || '3' ) ) {
		array_push( $buttons, 'separator', 'wpAppbox_AppboxButton' );
	}
	return( $buttons );
}


/**
* Buttons zum HTML-Editor hinzufügen
*
* @since   2.0.0
* @change  3.2.0
*
* @echo    string   Ausgabe des Scripts innerhalb TinyMCE
*/

function wpAppbox_addButtonsHTML() {
	global $wpAppbox_storeNames;
	$option = get_option('wpAppbox_defaultButton');
	if ( $option != '2' ) {
		if ( wp_script_is( 'quicktags' ) ) {
			echo( "<script type=\"text/javascript\">" );
			foreach ( $wpAppbox_storeNames as $storeID => $storeName ) {
				if ( get_option('wpAppbox_buttonHTML_'.$storeID) || $option == '0' ) echo( "QTags.addButton('htmlx_$storeID', 'Appbox: $storeID', '[appbox $storeID appid]', '', '', '$storeName');" );
			}
			echo( "</script>" );
		}
	}
}


/**
* Registrierung des Plugins
*
* @since   2.0.0
* @change  3.2.0
*
* @param   array  $plugin_array     Plugin-Array [WordPress]
* @return  array  $plugin_array     Plugin-Array [WordPress]
*/

function wpAppbox_register( $plugin_array ) {
	global $wpAppbox_storeNames;
	$option = get_option('wpAppbox_defaultButton');
	foreach ( $wpAppbox_storeNames as $storeID => $storeName ) {
		if ( get_option("wpAppbox_buttonAppbox_$storeID") ) $iscombined = true;
	}
	if ( $option == '1' || $option == '3' ) {
		if ( $iscombined || $option == '1' ) {
			if ( version_compare( get_bloginfo('version'), '3.9', '>=') ) {
				$plugin_array['wpAppbox_CombinedButton'] = plugins_url( "buttons/combined.btn.js.php", __FILE__ );
			} else {
				$plugin_array['wpAppboxCombined'] = plugins_url( "buttons/combined.btn.old.js.php", __FILE__ );
			}
		}
	}
	if ( $option == '0' || $option == '3' ) $plugin_array["wpAppboxSingle"] = plugins_url( "buttons/single.btn.js.php", __FILE__ );
	return( $plugin_array );
}


/**
* "Einstellungen"-Link zur Plugin-Liste hinzufügen
*
* @since   2.0.0
* @change  3.2.0
*
* @param   array   $links  Array der eingetragenen Links [WordPress]
* @param   string  $file   Aufgerufene Datei [WordPress]
* @return  array   $links  Rückgabe der überarbeiteten Links [WordPress]
*/

function wpAppbox_addSettings( $links, $file ) {
	static $this_plugin;
	if ( !$this_plugin ) $this_plugin = plugin_basename( __FILE__ );
	if ( $file == $this_plugin ) {
		$settings_link = '<a href="options-general.php?page=wp-appbox">' . __('Settings', 'wp-appbox') . '</a>';
		$links = array_merge( array( $settings_link ), $links );
	}
	return( $links );
}


/**
* Weitere Links zur Plugin-Beschreibung in der Liste hinzufügen
*
* @since   2.0.0
* @change  3.2.0
*
* @param   array   $links  Array der eingetragenen Links [WordPress]
* @param   string  $file   Aufgerufene Datei [WordPress]
* @return  array   $links  Rückgabe der überarbeiteten Links [WordPress]
*/

function wpAppbox_addLinks( $links, $file ) {
	static $this_plugin;
	if ( !$this_plugin ) {
		$this_plugin = plugin_basename( __FILE__ );
	}
	if ( $file == $this_plugin ) {
		$links = array();
		$links[] = 'Version '.WPAPPBOX_PLUGIN_VERSION;
		$links[] = '<a target="_blank" href="https://twitter.com/Marcelismus">' . __('Follow me on Twitter', 'wp-appbox') . '</a>';
		$links[] = '<a target="_blank" href="http://www.blogtogo.de/wp-appbox-app-badge-fuer-google-play-mac-app-store-windows-store-windows-phone-store-co/">' . __('Plugin page', 'wp-appbox') . '</a>';
		$links[] = '<a target="_blank" href="http://wordpress.org/support/view/plugin-reviews/wp-appbox">' . __('Rate the plugin', 'wp-appbox') . '</a>';
		$links[] = '<a target="_blank" href="http://www.amazon.de/gp/registry/wishlist/1FC2DA2J8SZW7">' . __('My Amazon Wishlist', 'wp-appbox') . '</a>';
		$links[] = '<a target="_blank" href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=SH9AAS276RAS6">' . __('PayPal-Donation', 'wp-appbox') . '</a>';
	}
	return( $links );
}


/**
* Ausgabe von Fehlermeldungen
*
* @since   2.0.0
* @change  3.2.0
*
* @param   string  $message  Fehlermeldung
*/

function br_trigger_error( $message ) {
    if ( isset( $_GET['action'] ) && $_GET['action'] == 'error_scrape' ) {
        echo( "<strong>$message</strong>" );
        exit;
    } else {
    	trigger_error( $message, E_USER_ERROR );
    }
}


/**
* Aktivierung des Plugins
*
* @since   2.0.0
* @change  3.2.0
*/

function wpAppbox_activate() {
	if ( version_compare(phpversion(), '5.0') == -1 ) br_trigger_error( __('To use this plugin requires at least PHP version 5.0 is required.', 'wp-appbox') );
	if ( !function_exists('curl_init') ) br_trigger_error( __('"cURL" is disabled on this server, but is required. Please enable this feature (or contact your hoster).', 'wp-appbox') ); 
	if ( !function_exists('curl_exec') ) br_trigger_error( __('"curl_exec" is disabled on this server, but is required. Please enable this feature (or contact your hoster).', 'wp-appbox') ); 
	if ( !function_exists('json_decode') ) br_trigger_error( __('"json_decode" is disabled on this server, but is required. Please enable this feature (or contact your hoster).', 'wp-appbox') ); 
	wpAppbox_setOptions();
}


/**
* Deinstallation des Plugins
*
* @since   2.0.0
* @change  3.2.0
*/

function wpAppbox_uninstall() {
	global $wpdb;
	$wpdb->query( "DELETE FROM wp_options WHERE option_name LIKE 'wpAppbox_%';" );
	delete_option( "wpAppbox" ); //Für ältere Versionen ==> bis 3.1.6
	wpAppbox_deleteTable();
}


/**
* Stylesheet des Plugins registrieren
*
* @since   2.0.0
* @change  3.2.0
*/

function wpAppbox_RegisterStyle() {
	if ( get_option('wpAppbox_disableCSS') == false ) {
		wp_register_style( 'wpappbox', plugins_url( 'css/styles.min.css', __FILE__ ), array(), WPAPPBOX_PLUGIN_VERSION, 'screen' );
		wp_enqueue_style( 'wpappbox' );
	}
}


/**
* Google Fonts für das Plugin registrieren
*
* @since   2.0.0
* @change  3.2.0
*/

function wpAppbox_loadFonts() {
	if ( get_option('wpAppbox_disableFonts') == false ) {
		wp_register_style( 'open-sans', '//fonts.googleapis.com/css?family=Open+Sans:400,600' );
		wp_enqueue_style( 'open-sans' );
	}
}


/* DER Shortcode */ 
add_shortcode( 'appbox', 'wpAppbox_createAppbox' );


/* Diverse Filter, Aktionen und Hooks registrieren */
add_filter( 'mce_external_plugins', "wpAppbox_register" );
add_filter( 'mce_buttons', 'wpAppbox_addButtonsWYSIWYG', 0 );
add_filter( 'plugin_action_links', 'wpAppbox_addSettings', 10, 2 );
add_filter( 'plugin_row_meta', 'wpAppbox_addLinks', 10, 2 );
add_action( 'admin_menu', 'wpAppbox_pageInit' );
add_action( 'admin_init', 'wpAppbox_adminInit' );
add_action( 'admin_print_footer_scripts', 'wpAppbox_addButtonsHTML' );
//add_action( 'wp_enqueue_scripts', 'wpAppbox_RegisterStyle' );
//add_action( 'wp_print_styles', 'wpAppbox_loadFonts' );
register_activation_hook( __FILE__, 'wpAppbox_activate' );
register_uninstall_hook( __FILE__, 'wpAppbox_uninstall' );


/* Update durchführen und App-Cache aufräumen */
wpAppbox_UpdateAction();
if ( wpAppbox_isUserAuthor() ) wpAppbox_cleanCache();

?>